/*
 * Copyright  2014 The MorphOS Development Team
 *
 * $Id: hashtab.c,v 1.2 2014/03/09 02:30:54 itix Exp $
 */

#include "hashtab.h"

CONST_APTR hashtab_get(const hashtable *h, CONST_APTR val, size_t stringNum)
{
	size_t idx = HASH_INDEX(h, stringNum);
	CONST Bucket *b = &h->buckets[idx];

	if (b->value != NULL)
	{
		if (b->key != stringNum)
		{
			size_t *ptr = h->chaining;

			if (ptr == NULL)
				return val;

			for (;;)
			{
				if (ptr[idx] == 0)
					return val;

				idx = ptr[idx] - 1;
				b = &h->buckets[idx];

				if (b->key == stringNum)
					break;
			}
		}

		val = b->value;
	}

	return val;
}
